// Author: TGGC (http://pc.exit.de/tggc)

#include <string.h>
#include <stdio.h>


struct part
{
	char	m_pcName[30];
	float	m_fLength;
	float	m_fWidth;
	float	m_fPrize;
	int		m_iNrOf;

	void	out(void);
	void	copy(part* pPart);
};

void part::out(void)
{
	printf(	"%-30s     %6.2f*%6.2f     %3d*%6.2fDM=%8.2fDM\n",
			m_pcName,
			m_fLength,
			m_fWidth,
			m_iNrOf,
			m_fPrize,
			m_iNrOf*m_fPrize);
};

void part::copy(part* pPart)
{
	strcpy(m_pcName,pPart->m_pcName);
	m_fLength=pPart->m_fLength;
	m_fWidth=pPart->m_fWidth;
	m_fPrize=pPart->m_fPrize;
	m_iNrOf=pPart->m_iNrOf;
}


struct tree
{
	part*	m_pPart;
	tree*	m_pLeft;
	tree*	m_pRight;

			tree(void);
	void	add(part* pPart);
	void	outprae(void);
	void	outpost(void);
};

tree::tree(void)
{
	m_pPart=NULL;
	m_pLeft=NULL;
	m_pRight=NULL;
};

void tree::add(part* pPart)
{
	if (m_pPart==NULL)
	{
		m_pPart=new part;
		m_pPart->copy(pPart);
	}
	else
	{
		if (strcmp(pPart->m_pcName,m_pPart->m_pcName)<0)
		{
			if (m_pLeft==NULL) m_pLeft= new tree;
			m_pLeft->add(pPart);
		}
		else
		{
			if (m_pRight==NULL) m_pRight= new tree;
			m_pRight->add(pPart);
		}
	}
}

void tree::outpost(void)
{
	if (m_pLeft) m_pLeft->outpost();
	if (m_pPart) m_pPart->out();
	if (m_pRight) m_pRight->outpost();
}

void tree::outprae(void)
{
	if (m_pPart) m_pPart->out();
	if (m_pLeft) m_pLeft->outprae();
	if (m_pRight) m_pRight->outprae();
}

bool readfile(char* pcFileName, tree* treeRoot)
{
	FILE*	fileText;
	part	partTmp;

	fileText=fopen(pcFileName,"r");

	if (fileText==NULL)
		return false;

	while(	fscanf(	fileText,
					"%s\n%f*%f;%f;%d\n",
					partTmp.m_pcName,
					&(partTmp.m_fLength),
					&(partTmp.m_fWidth),
					&(partTmp.m_fPrize),
					&(partTmp.m_iNrOf))!=EOF)
	{
		treeRoot->add(&partTmp);
	}

	return true;
}

int main(void)
{
	tree treeRoot;

	readfile("teile.txt",&treeRoot);
    printf("---Praeordnug---\n");
	treeRoot.outprae();
	getchar();

    printf("---Postordnug---\n");
	treeRoot.outpost();
	getchar();

	return 0;
}

